use super::{JournalChecker, KillSubscriptionType, award_journal_if_needed};
use crate::{
    DResult,
    static_content::species::SpeciesType,
    models::{
        user::User,
        item::Item,
        journal::JournalType,
    }
};
use async_trait::async_trait;
use mockall_double::double;
#[double] use crate::db::DBTrans;

pub struct FirstDogChecker;
#[async_trait]
impl JournalChecker for FirstDogChecker {
    fn kill_subscriptions(&self) -> Vec<KillSubscriptionType> {
        vec!(
            KillSubscriptionType::SpecificNPCSpecies {
                species: SpeciesType::Dog
            }
        )
    }

    async fn handle_kill(
        &self,
        trans: &DBTrans,
        user: &mut User,
        player: &mut Item,
        _victim: &Item
    ) -> DResult<bool> {
        award_journal_if_needed(trans, user, player, JournalType::SlayedMeanDog).await
    }
}

pub static CHECKER: FirstDogChecker = FirstDogChecker;
